
#ifndef __LIBRARY_H__
#define __LIBRARY_H__

#include <QMutex>
#include <QList>

#include "interface.h"

namespace jhead
{

class Library : public JHead
{
public:
           Library ( );
  virtual ~Library ( );

  virtual Info *getFileInfo ( QString &qsFile, QString *pThumb=NULL );
  void lock   ( );
  void unlock ( );

  // Here are the calls to the API.
  virtual bool hasThumbnail            ( );
  virtual QDateTime getCreationDate    ( );
  virtual void saveThumbnail ( QString & );
  virtual int getWidth                 ( );
  virtual int getHeight                ( );

private:
//  QList<Info *> m_listOfFileInfos;
  Info *m_pInfo;
  static QMutex m_mutex;
};

}; // end of namespace jhead

#endif // __LIBRARY_H__

